"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRealVersion = exports.existsFile = exports.readFile = void 0;
const assert_1 = __importDefault(require("assert"));
const got_1 = __importDefault(require("got"));
const UNPKG_SERVER = 'https://unpkg.alibaba-inc.com';
async function readFile(opts) {
    const url = `${UNPKG_SERVER}/${opts.name}@${opts.version}/${opts.file}`;
    const res = await got_1.default(url, {
        followRedirect: true,
    });
    assert_1.default(res.statusCode === 200, `文件 ${opts.name}/${opts.version}/${opts.file} 不存在`);
    return res.body;
}
exports.readFile = readFile;
async function existsFile(opts) {
    const url = `${UNPKG_SERVER}/browse/${opts.name}@${opts.version}/${opts.file}`;
    try {
        await got_1.default(url, {
            followRedirect: false,
        });
        return true;
    }
    catch (_e) {
        return false;
    }
}
exports.existsFile = existsFile;
async function getRealVersion(opts) {
    const url = `${UNPKG_SERVER}/browse/${opts.name}@${opts.version}/`;
    try {
        const res = await got_1.default(url, {
            method: 'HEAD',
            followRedirect: false,
        });
        console.log(res.statusCode);
        console.log(res.headers);
    }
    catch (e) {
        console.log('error');
    }
}
exports.getRealVersion = getRealVersion;
