"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceImports = void 0;
// @ts-ignore
const is_core_module_1 = __importDefault(require("is-core-module"));
const isRelative_1 = require("./isRelative");
function replaceImports(opts) {
    const depImports = [];
    const localImports = [];
    let content = opts.content;
    const externals = opts.externals || {};
    content = content.replace(/(import.+?from) ['"]([^'"]+)['"]/g, (a, b, c) => {
        c = c.replace(/\.js$/, '');
        // asdf is from cjs-module-lexer
        if (['./ab', 'asdf', '...'].includes(c)) {
            return `${b}('${c}')`;
        }
        if (isRelative_1.isRelative(c)) {
            localImports.push(c);
            return `${b} '${c}'`;
        }
        else if (is_core_module_1.default(c)) {
            return `${b} '${c}'`;
        }
        else if (externals[c]) {
            return `${b} '${externals[c]}'`;
        }
        else {
            depImports.push(c);
            return `${b} '${opts.prefix}${c}'`;
        }
    });
    content = content.replace(/(import)\(['"]([^'"]+)['"]\)/g, (a, b, c) => {
        c = c.replace(/\.js$/, '');
        // ./ab, asdf is from cjs-module-lexer
        // ... is from webpack
        if (['./ab', 'asdf', '...'].includes(c)) {
            return `${b}('${c}')`;
        }
        if (isRelative_1.isRelative(c)) {
            localImports.push(c);
            return `${b}('${c}')`;
        }
        else if (is_core_module_1.default(c)) {
            return `${b}('${c}')`;
        }
        else if (externals[c]) {
            return `${b}('${externals[c]}')`;
        }
        else {
            depImports.push(c);
            return `${b}('${opts.prefix}${c}')`;
        }
    });
    content = content.replace(/(import[^=]+?=.+?require)\(['"]([^'"]+)['"]\)/g, (a, b, c) => {
        if (['./ab', 'asdf', '...'].includes(c)) {
            return `${b}('${c}')`;
        }
        if (isRelative_1.isRelative(c)) {
            localImports.push(c);
            return `${b}('${c}')`;
        }
        else if (is_core_module_1.default(c)) {
            return `${b}('${c}')`;
        }
        else if (externals[c]) {
            return `${b}('${externals[c]}')`;
        }
        else {
            depImports.push(c);
            return `${b}('${opts.prefix}${c}')`;
        }
    });
    // TODO: <reference />
    // ref: https://www.typescriptlang.org/docs/handbook/triple-slash-directives.html
    return {
        content,
        depImports,
        localImports,
    };
}
exports.replaceImports = replaceImports;
